/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package common;

import java.awt.Color;


public class Globals {

	// The accuracy of the calculated reflection points
	public final static int CALC_ACCURACY = 8;
	public final static short[] PRECISIONS	= 
		new short[]{125,250,500,1000,2000,4000,8000,16000,32000};
	public final static short[] SHAPE_SIZES = 
		new short[]{10,20,30,40,50,60,70,80,90};
	public static short[] GRID_SIZES = 
		new short[]{1,2,3,4,5,6,7,8,9,10,20,30,40,50};
	public static byte IDX_PREC = 2;
	public static byte IDX_SHAPE_SIZE = 4;
	public static byte IDX_GRID_SIZE = 1;
	public static boolean LOG_VERBOSE = false;
	public static final short CALC_TIME_BASE = 1000;
	public static boolean AUTO_PREC = false;
	public static boolean AUTO_RADIUS = false;
	public static Color INPUT_BG = new Color(220,180,180);
	public final static byte getIndex(short val,short[] array) {
		for(byte i = 0;i<array.length;i++)
			if(val==array[i])
				return i;
		return -1;
	}
	public final static void addGridSize(short s) {
		if(s>=0&&getIndex(s,GRID_SIZES)==-1) {
			int k = 0;
			while(k<GRID_SIZES.length)
				if(s<=GRID_SIZES[k++])
					break;
			k--;
			short[] sizes = new short[GRID_SIZES.length+1];
			System.arraycopy(GRID_SIZES,0,sizes,0,k);
			System.arraycopy(GRID_SIZES,k,sizes,k+1,GRID_SIZES.length-k);
			sizes[k] = s;
			GRID_SIZES = sizes;
		}
	}
	public final static boolean adjustPrecision(int p){
		for(byte i = 0;i<Globals.PRECISIONS.length;i++)
			if(Globals.PRECISIONS[i]>=p){
				if(Globals.IDX_PREC!=i){
					Globals.IDX_PREC = i;
					return true;
				}
				break;
			}
		return false;
	} 
}
