/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package math;

public final class VecMathFloat extends VecMath<Float> {

	public VecMathFloat() {
		super(new UtilFloat(),8,false,false);
	}
	public Float add(Float x,Float y) {
		return x+y;
	}
	public Float div(Float x,Float y) {
		return x/y;
	}
	public Float mul(Float x,Float y) {
		return x*y;
	}
	public Float mul(Float x,int i) {
		return x*i;
	}
	public Float neg(Float x) {
		return -x;
	}
	public Float sin(Float x) {
		return (float)Math.sin(x);
	}
	public Float asin(Float x) {
		return (float)Math.asin(x);
	}
	public Float cos(Float x) {
		return (float)Math.cos(x);
	}
	public Float acos(Float x) {
		return (float)Math.acos(x);
	}
	public Float tan(Float x) {
		return (float)Math.tan(x);
	}
	public Float atan(Float x) {
		return (float)Math.atan(x);
	}
	public Float log(Float x) {
		return (float)Math.log(x);
	}
	public Float sqrt(Float x) {
		return (float)Math.sqrt(x);
	}
	public Float sqrt(Float x,int p) {
		return (float)Math.sqrt(x);
	}
	public Float sub(Float x,Float y) {
		return x-y;
	}
	public byte cmp(Float x,Float y) {
		if(x<y)
			return -1;
		if(x>y)
			return 1;
		return 0;
	}
	public Float inv(Float x) {
		return 1/x;
	}
	public Float abs(Float x) {
		return Math.abs(x);
	}
	public Float mod(Float x,Float y) {
		return x%y;
	}
	public Float pow(Float x,int ex) {
		return (float)Math.pow(x,ex);
	}
	public Float pow(Float x,Float y) {
		return (float)Math.pow(x,y);
	}
	public byte sign(Float x) {
		return (byte)Math.signum(x);
	}
	public Float[] discrSinCos(float fact) {
		return sincos((float)(fact*Math.PI));
	}
}
