/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package mvc.var;
import java.awt.event.KeyEvent;

import javax.swing.JOptionPane;
import javax.swing.JTextField;

import mvc.Controller;

public abstract class RayKeyListener<T extends Number> extends BaseKeyListener<T> {
	
	private final JTextField textField;
	public RayKeyListener(Controller<T> c,JTextField tf,boolean exp) {
		super(c,exp);
		this.textField = tf;
	}
	@Override
	public void keyReleased(KeyEvent e) {
		if(e.getKeyCode()==KeyEvent.VK_ENTER) {
			ctrl.stopCalculation();
			try {
				ctrl.waitForCalculatorRelease();
				boolean expand = removeNonNumberChars(textField);
				T val = getValue(textField.getText().trim(),expand);
				handleValue(val);
				ctrl.startCalculation();
			} catch(NumberFormatException ex) {
				String msg = "Can't read number. "+ex.getMessage();
				JOptionPane.showMessageDialog(textField,msg);
			}
		}
	}
	abstract void handleValue(T val);
}
