/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package parser;
import java.util.ArrayList;

import math.VecMath;

abstract class Expression<T extends Number> {

	private final ArrayList<Expression<T>> childs;
	final VecMath<T> math;
	Expression(VecMath<T> math) {
		this.childs = new ArrayList<Expression<T>>();
		this.math = math;
	}
	abstract T getValue() throws Exception;
	void addChild(Expression<T> n) {
		childs.add(n);
	}
	Expression<T> getChild(int i) {
		return childs.get(i);
	}
	short getChildCount() {
		return (short)childs.size();
	}
}
