/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package pattern;
public interface ILightPattern<T extends Number> extends ILightPatternSequence {

	int estimateCalcTime();
	T getRotation();
	T[] getStart(T worldX,T phi,T[] sinCosPhi);
	T getMaxShapeSize();
	short getGridSize();
	String getName();
	T getStartBndVal();
	T getEndBndVal();
	byte getStartBndValType();
	byte getEndBndValType();
	void setParameters(T[] gridCorner,T gap,T r);
	int getPeriod();
	int getAccuracyUpperBound();
	int getAccuracyLowerBound();
	int getAccuracy();
	boolean isStoreCalcEnabled();
	int getStartIndex();
	boolean isPropagating();
}
